/**
 * 教师画像（对内）-学业水平
 */

import { title } from "process";
import { xshxNENUM } from "../../config/interficeEnum";
import { getReqApiData } from "../../data/interface/url";
import { getKeyValue, readFileList } from "../outData";
import { jshxTableData } from "../../data/table/duiwai";
import { keyValuePackage, tablePackage } from "../../dataPackage/inFrontOut";
import { systemConfig } from "../../config/serverConfig";

const ImgUrl = "img/对内/学生画像/学业水平/";

/**各学科成绩分析 */
export async function getGxkcjfx(req, res) {
    let grade = req.body.grade || 1; //【一年级：1、二年级：2、三年级：3、四年级：4】
    let className = req.body.className || "一班";
    let score = req.body.className || "A";

    let ret:any = {};

    let zhpjf = [
        {
            key:"综合平均分",
            value:0,
            unit:"分"
        }
    ];
    ret["zhpjf"] = {title:"综合平均分", dataList:zhpjf};

    let gxkcjfx = {
        班级:[
            {
                key:"语文",
                value:30
            },
            {
                key:"数学",
                value:57
            },
            {
                key:"英语",
                value:41
            },
            {
                key:"品德",
                value:37
            },
            {
                key:"体育",
                value:24
            },
            {
                key:"音乐",
                value:30
            },
        ],
        年级:[
            {
                key:"语文",
                value:30
            },
            {
                key:"数学",
                value:57
            },
            {
                key:"英语",
                value:41
            },
            {
                key:"品德",
                value:37
            },
            {
                key:"体育",
                value:24
            },
            {
                key:"音乐",
                value:30
            },
        ],
        平均:[
            {
                key:"语文",
                value:30
            },
            {
                key:"数学",
                value:57
            },
            {
                key:"英语",
                value:41
            },
            {
                key:"品德",
                value:37
            },
            {
                key:"体育",
                value:24
            },
            {
                key:"音乐",
                value:30
            },
        ]
    };
    ret["gxkcjfx"] = {title:"各学科成绩分析", dataList:gxkcjfx};

    res.send(ret);
}


/**本学期学科变化趋势 */
export async function getBxqxkbhqs(req, res) {
    let grade = req.body.grade || 1; //【一年级：1、二年级：2、三年级：3、四年级：4】
    let className = req.body.className || "一班";
    let score = req.body.className || "A";

    let ret:any = {};

    let bxqxkbhqs = {
        期中:[
            {
                key:"语文",
                value:30
            },
            {
                key:"数学",
                value:57
            },
            {
                key:"英语",
                value:41
            },
            {
                key:"品德",
                value:37
            },
            {
                key:"体育",
                value:24
            },
            {
                key:"音乐",
                value:30
            },
        ],
        期末:[
            {
                key:"语文",
                value:30
            },
            {
                key:"数学",
                value:57
            },
            {
                key:"英语",
                value:41
            },
            {
                key:"品德",
                value:37
            },
            {
                key:"体育",
                value:24
            },
            {
                key:"音乐",
                value:30
            },
        ]
    };
    ret["bxqxkbhqs"] = {title:"本学期学科变化趋势", dataList:bxqxkbhqs};

    res.send(ret);
}


/**整体数据 */
export async function getData(req, res) {
    let grade = req.body.grade || 1; //【一年级：1、二年级：2、三年级：3、四年级：4】
    let className = req.body.className || "一班";
    // let score = req.body.className || "A";

    let ret:any = {};

    let zhms = [
        {
            key:"得A率",
            value:90,
            unit:"%"
        },
        {
            key:"得B率",
            value:90,
            unit:"%"
        },
        {
            key:"得C率",
            value:90,
            unit:"%"
        },
        {
            key:"得D率",
            value:90,
            unit:"%"
        },
    ];
    ret["zhms"] = {title:"综合面试", dataList:zhms};

    let khxxsc = {
        在校:[
            {
                key:"一月",
                value:100
            },
            {
                key:"二月",
                value:100
            },
            {
                key:"三月",
                value:100
            },
            {
                key:"四月",
                value:100
            },
            {
                key:"五月",
                value:100
            },
            {
                key:"六月",
                value:100
            },
            {
                key:"七月",
                value:100
            },
            {
                key:"八月",
                value:100
            },
        ],
        课后作业:[
            {
                key:"一月",
                value:100
            },
            {
                key:"二月",
                value:100
            },
            {
                key:"三月",
                value:100
            },
            {
                key:"四月",
                value:100
            },
            {
                key:"五月",
                value:100
            },
            {
                key:"六月",
                value:100
            },
            {
                key:"七月",
                value:100
            },
            {
                key:"八月",
                value:100
            },
        ],
    };
    ret["khxxsc"] = {title:"课后学习时长", dataList:khxxsc};

    let zywcqk = [
        {
            key:"课后作业",
            value:0
        },
        {
            key:"探究作业",
            value:0
        },
        {
            key:"打卡作业",
            value:0
        }
    ];
    ret["zywcqk"] = {title:"作业完成情况", dataList:zywcqk};

    let xydjdb = {
        班级:[
            {
                key:"A等",
                value:97
            },
            {
                key:"B等",
                value:17
            },
            {
                key:"C等",
                value:77
            },
            {
                key:"D等",
                value:23
            },
            {
                key:"E等",
                value:11
            },
        ],
        年级:[
            {
                key:"A等",
                value:87
            },
            {
                key:"B等",
                value:97
            },
            {
                key:"C等",
                value:71
            },
            {
                key:"D等",
                value:21
            },
            {
                key:"E等",
                value:19
            },
        ],
    };
    ret["xydjdb"] = {title:"学业等级对比", dataList:xydjdb};

    let xyjc = {
        语文:[
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XXX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
        ],
        数学:[
            {
                key:"王XX",
                value:"优秀"
            },
            {
                key:"王XX",
                value:"优秀"
            },
            {
                key:"孔XXX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
        ],
        英语:[
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XXX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
        ],
        物理:[
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XXX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
        ],
        化学:[
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XXX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
        ],
        生物:[
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XXX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
        ],
        历史:[
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XXX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
            {
                key:"孔XX",
                value:"优秀"
            },
        ]
    };
    ret["xyjc"] = {title:"学业检测", dataList:xyjc};

    let mcjbyxxs = [
        {
            key:"孔维玮",
            value:"进步13",
            state:"良好"
        },
        {
            key:"朱清仪",
            value:"进步10",
            state:"良好"
        },
        {
            key:"寇仟凡玉",
            value:"进步5",
            state:"良好"
        },
        {
            key:"张恒",
            value:"进步11",
            state:"良好"
        },
        {
            key:"刘抒辰",
            value:"进步13",
            state:"良好"
        },
        {
            key:"冯跃如",
            value:"进步9",
            state:"良好"
        },
    ];
    ret["mcjbyxxs"] = {title:"名次进步优秀学生（年级前30名）", dataList:mcjbyxxs, count:22}

    let xksyj = [
        {
            key:"郭晋同",
            evaluate:"优秀",
            value:"名次113"
        },
        {
            key:"杨均文",
            evaluate:"优秀",
            value:"名次104"
        },
        {
            key:"朱亦腾",
            evaluate:"优秀",
            value:"名次110"
        },
        {
            key:"仲韬",
            evaluate:"优秀",
            value:"名次127"
        },
        {
            key:"邱云汉",
            evaluate:"优秀",
            value:"名次99"
        },
    ];
    ret["xksyj"] = {title:"学困生预警", dataList:xksyj, count:11};

    res.send(ret);
}


/**下拉成绩等级 */
export async function getRank(req, res) {
    let ret:any = {};

    let rank = ["A", "B", "C", "D", "E", "F", "G"];
    ret["rank"] = {title:"成绩等级下拉", dataList:rank};

    res.send(ret);
}












