/**
 * 教师画像（对内）-综合实践活动参与情况
 */

import { title } from "process";
import { xshxNENUM } from "../../config/interficeEnum";
import { getReqApiData } from "../../data/interface/url";
import { getKeyValue, readFileList } from "../outData";
import { jshxTableData } from "../../data/table/duiwai";
import { keyValuePackage, tablePackage } from "../../dataPackage/inFrontOut";
import { systemConfig } from "../../config/serverConfig";

const ImgUrl = "img/对内/学生画像/综合实践活动参与情况/";


/**左侧 */
export async function getTddyhd(req, res) {
    let grade = req.body.grade || 1; //【一年级：1、二年级：2、三年级：3、四年级：4】
    let className = req.body.className || "一班";
    let ret:any = {};

    let cyrc = [
        {
            key:"参与人次",
            value:243
        }
    ];
    ret["cyrc"] = {title:"参与人次", dataList:cyrc};

    let tddyhd = [
        {
            key:"活动类型",
            value:12
        },
        {
            key:"仪式活动",
            value:30
        },
        {
            key:"主题教育",
            value:27
        },
        {
            key:"团课",
            value:19
        },
        {
            key:"队课",
            value:10
        },
    ];
    ret["tddyhd"] = {title:"团队德育活动", dataList:tddyhd};

    let shsjqk = [
        {
            key:"社会考察",
            period:8,
            rate:100
        },
        {
            key:"公益劳动",
            period:10,
            rate:87
        },
        {
            key:"职业体验",
            period:2,
            rate:100
        },
        {
            key:"安全实训",
            period:0,
            rate:90
        },
    ];
    ret["shsjqk"] = {title:"社会实践情况", dataList:shsjqk};

    let zhpjdAl = [
        {
            key:"学习态度",
            value:"待评价"
        },
        {
            key:"课堂表现",
            value:"待评价"
        },
        {
            key:"综合评价",
            value:"待评价"
        }
    ];
    ret["zhpjdAl"] = {title:"综合评价得A率", dataList:zhpjdAl};

    let zywcqk = [
        {
            key:"作业完成情况",
            value:"待评价"
        },
        {
            key:"课堂表现",
            value:"待评价"
        },
        {
            key:"综合评价",
            value:"待评价"
        }
    ];
    ret["zywcqk"] = {title:"作业完成情况", dataList:zywcqk};


    res.send(ret);
}


/**基础数据 */
export async function getData(req, res) {
    let grade = req.body.grade || 1; //【一年级：1、二年级：2、三年级：3、四年级：4】
    let ret:any = {};

    let xshjcgzs = [
        {
            key:"获奖人次",
            value:39
        },
        {
            key:"国家级",
            value:2
        },
        {
            key:"市级",
            value:0
        },
        {
            key:"区级",
            value:4
        },
        {
            key:"校级",
            value:33
        },
    ];
    ret["xshjcgzs"] = {title:"学生获奖成果展示", dataList:xshjcgzs};

    let hdfcImg = readFileList(`${ImgUrl}活动风采/`, [], "png");
    let hdfc = [];
    for(let i = 0; i < hdfcImg.length; i++) {
        hdfc.push({key:i+1+"*******", value:hdfcImg[i]});
    }
    ret["hdfc"] = {title:"活动风采", dataList:hdfc};

    let cxjsysjnl = [
        {
            key:"科研课题",
            value:0
        },
        {
            key:"科研成果",
            value:0
        },
    ];
    ret["cxjsysjnl"] = {title:"创新精神与实践能力", dataList:cxjsysjnl};

    let kykt = {
        titleList:["时间", "类型", "课题名称", "指导老师", "是否跨学科"],
        dataList:[
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
        ]
    };
    ret["kykt"] = {title:"科研课题", dataList:kykt};

    let kxkkt = {
        titleList:["时间", "类型", "课题名称", "指导老师", "是否跨学科"],
        dataList:[
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
        ]
    };
    ret["kxkkt"] = {title:"跨学科课题", dataList:kxkkt};

    let gjglhd = [
        {
            key:"科技",
            value:2
        },
        {
            key:"人文",
            value:2
        },
        {
            key:"艺术",
            value:4
        },
        {
            key:"健康",
            value:3
        },
    ];
    ret["gjglhd"] = {title:"各级各类活动", dataList:gjglhd};

    let gjglhdxx = {
        titleList:["活动时间", "活动名称", "活动类型", "招生人数", "课时数"],
        dataList:[
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
        ]
    };
    ret["gjglhdxx"] = {title:"各级各类活动表格", dataList:gjglhdxx};

    let shsjhdjl = {
        titleList:["活动时间", "活动名称", "活动类型", "参与人数", "课时数"],
        dataList:[
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
        ]
    };
    ret["shsjhdjl"] = {title:"社会实践活动记录", dataList:shsjhdjl};

    let zhsjhdcyqk = {
        titleList:["活动时间", "活动名称", "活动类型", "参与人数", "课时数"],
        dataList:[
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
            ["-", "-", "-", "-", "-"],
        ]
    };
    ret["zhsjhdcyqk"] = {title:"综合实践活动参与情况", dataList:zhsjhdcyqk};


    res.send(ret);
}


/**中间底部-班级特色活动 */
export async function getBjtshd(req, res) {
    let grade = req.body.grade || 1; //【一年级：1、二年级：2、三年级：3、四年级：4】
    let className = req.body.className || "一班";
    let ret:any = {};

    let tshdsl = [
        {
            key:"特色活动数量",
            value:"待组织"
        }
    ];
    ret["tshdsl"] = {title:"特色活动数量", dataList:tshdsl};

    let bjtshd = {
        titleList:["活动时间", "活动名称", "活动类型", "参与人数"],
        dataList:[
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
            ["-", "-", "-", "-"],
        ]
    }
    ret["bjtshd"] = {title:"班级特色活动", dataList:bjtshd};

    let hdlyImg = readFileList(`${ImgUrl}活动掠影/`, [], "png");
    let hdly = [];
    for (let i = 0; i < hdlyImg.length; i++) {
        hdly.push({time:"2024-01-26", img:hdlyImg[i], txt:"********************"})
    }
    ret["hdly"] = {title:"活动掠影", dataList:hdly};

    res.send(ret);
}


/**
 * 部门负责人
 * @param req 
 * @param res 
 */
export async function getBmfzr(req, res) {
    let userId = req.query.userId;
    let deptId = req.query.deptId;
    let ret:any = {};
    let bmfzrData = await getReqApiData(xshxNENUM.获取部门负责人, {userId, deptId});
    ret["bmfzr"] = bmfzrData;

    res.send(ret);
}






